# Swagger\Client\RecipientsApi

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getRecipients**](RecipientsApi.md#getrecipients) | **GET** /recipients | /recipients

# **getRecipients**
> \Swagger\Client\Model\Recipients getRecipients($object_limit, $object_offset, $filter_job_id, $filter_same_account, $filter_fax_number, $filter_fax_number_norm, $filter_recipient_reference, $filter_international_dialing_code, $filter_result_code, $filter_result_text, $sort_field, $sort_order)

/recipients

Description: To obtain a list of recipients

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\RecipientsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$object_limit = 100; // int | Query parameter to change de default limitation of objects in the result data array
$object_offset = 0; // int | Query parameter to change de default offset of objects in the result data array
$filter_job_id = "filter_job_id_example"; // string | Query parameter to fetch after recipient related to specific fax job
$filter_same_account = false; // bool | Query parameter to fetch recipient related to jobs linked to the used token/key for authorization
$filter_fax_number = "filter_fax_number_example"; // string | Query parameter to fetch recipients after his fax number
$filter_fax_number_norm = "filter_fax_number_norm_example"; // string | Query parameter to fetch recipients after his normed fax number
$filter_recipient_reference = "filter_recipient_reference_example"; // string | Query parameter to fetch recipients after his recipient reference
$filter_international_dialing_code = "filter_international_dialing_code_example"; // string | Query parameter to fetch recipients after his international dialing code
$filter_result_code = "filter_result_code_example"; // string | Query parameter to fetch recipients after his result code
$filter_result_text = "filter_result_text_example"; // string | Query parameter to fetch recipients after his result text
$sort_field = "sort_field_example"; // string | Available sort options for the result data array.
$sort_order = "asc"; // string | Describes the order for used sort fields

try {
    $result = $apiInstance->getRecipients($object_limit, $object_offset, $filter_job_id, $filter_same_account, $filter_fax_number, $filter_fax_number_norm, $filter_recipient_reference, $filter_international_dialing_code, $filter_result_code, $filter_result_text, $sort_field, $sort_order);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RecipientsApi->getRecipients: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **object_limit** | **int**| Query parameter to change de default limitation of objects in the result data array | [optional] [default to 100]
 **object_offset** | **int**| Query parameter to change de default offset of objects in the result data array | [optional] [default to 0]
 **filter_job_id** | **string**| Query parameter to fetch after recipient related to specific fax job | [optional]
 **filter_same_account** | **bool**| Query parameter to fetch recipient related to jobs linked to the used token/key for authorization | [optional] [default to false]
 **filter_fax_number** | **string**| Query parameter to fetch recipients after his fax number | [optional]
 **filter_fax_number_norm** | **string**| Query parameter to fetch recipients after his normed fax number | [optional]
 **filter_recipient_reference** | **string**| Query parameter to fetch recipients after his recipient reference | [optional]
 **filter_international_dialing_code** | **string**| Query parameter to fetch recipients after his international dialing code | [optional]
 **filter_result_code** | **string**| Query parameter to fetch recipients after his result code | [optional]
 **filter_result_text** | **string**| Query parameter to fetch recipients after his result text | [optional]
 **sort_field** | **string**| Available sort options for the result data array. | [optional]
 **sort_order** | **string**| Describes the order for used sort fields | [optional] [default to asc]

### Return type

[**\Swagger\Client\Model\Recipients**](../Model/Recipients.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

